#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=wtheora.ico
#AutoIt3Wrapper_Res_Comment=GUI pour ffmpeg2theora
#AutoIt3Wrapper_Res_Description=GUI pour ffmpeg2theora
#AutoIt3Wrapper_Res_Fileversion=1.3.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Nicolas Ricquemaque
#AutoIt3Wrapper_Res_Language=1036
#AutoIt3Wrapper_Res_Icon_Add=new.ico
#AutoIt3Wrapper_Res_Icon_Add=save.ico
#AutoIt3Wrapper_Res_Icon_Add=go.ico
#AutoIt3Wrapper_Res_Icon_Add=info.ico
#AutoIt3Wrapper_Res_Icon_Add=home.ico
#AutoIt3Wrapper_Res_Icon_Add=video.ico
#AutoIt3Wrapper_Res_Icon_Add=fyellow.ico
#AutoIt3Wrapper_Res_Icon_Add=fred.ico
#AutoIt3Wrapper_Res_Icon_Add=help.ico
#AutoIt3Wrapper_Res_Icon_Add=newb.ico
#AutoIt3Wrapper_Res_Icon_Add=newg.ico
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

;
; GUI pour ffmpeg2theora
;
#include <WindowsConstants.au3>
#include <GuiConstantsEx.au3>
#include <StaticConstants.au3>
#Include <GuiSlider.au3>
#include <SliderConstants.au3>
#include <ButtonConstants.au3>
#Include <File.au3>
#Include <WinAPI.au3>
#include <Constants.au3>
#include <EditConstants.au3>


$nom="Wtheora 1.3b - GUI pour ffmpeg2theora - CopyLeft Nicolas Ricquemaque 2008-2009 [CeCILL2]"

$Apropos= "Cette GUI a t ralise pour faciliter la conversion de vidos au format" & @CRLF
$Apropos&="Ogg/Theora/Vorbis  partir de ffmpeg2theora (http://v2v.cc/~j/ffmpeg2theora/)" & @CRLF
$Apropos&="Et notamment pallier  la difficult sous Windows d'y insrer des mtadonnes" & @CRLF
$Apropos&="accentues. Une fois les paramtres enregistrs, on peut simplement appeler" & @CRLF
$Apropos&="le logiciel en ligne de commande (ex: wtheora test.avi) sans passer par la GUI." & @CRLF
$Apropos&="On peut galement procder par glisser-dposer la vido sur l'icne de Wtheora." & @CRLF & @CRLF
$Apropos&="GUI ralise avec AutoIt3 (http://www.autoitscript.com/autoit3/) v" & @AutoItVersion
If (@AutoItUnicode) Then 
	$Apropos&="[Unicode]" & @CRLF
Else
	$Apropos&="[Ansi]" & @CRLF
EndIf
If (@AutoItX64) Then $Apropos&="[X64]" & @CRLF
$Apropos&=@CRLF & "Copyleft CeCILL2 - Nicolas Ricquemaque 2008-2009 - http://opensource.grisambre.net/wtheora"

$Installation=0

$ffmpegexe = RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","FFmpeg")
If (@error=1) Then
	If Not Licence() Then exit
	$Installation=1
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora")
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","FFmpeg","REG_SZ","")
EndIf
if ((NOT $ffmpegexe) OR CheckFile($ffmpegexe)<>2 ) Then
	$search = FileFindFirstFile(@ScriptDir & "\ffmpeg2theora*.exe")
	$file=""
	If ($search) Then $file=FileFindNextFile($search)
	If ($file) Then
		$ffmpegexe = @ScriptDir & "\" & $file
	Else 
		$wini=GuiCreate("Dcompression en cours...", 300, 130,-1,-1,$WS_EX_OVERLAPPEDWINDOW)
		If (Not @compiled) Then GUISetIcon("wtheora.ico")
		GUISetFont ("9" , 400)
		GuiCtrlCreateLabel("Installation de ffmpeg2theora v0.24 en cours..."&@CRLF&@CRLF&"Merci de patienter !", 20, 30)
		GuiSetState(@SW_SHOW,$wini)
		FileInstall("ffmpeg2theora-0.24.exe",@ScriptDir &"\ffmpeg2theora-0.24.exe")
		GUIDelete($wini)
		$ffmpegexe = @ScriptDir & "\ffmpeg2theora-0.24.exe" 
	EndIf
	FileClose($search)
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","FFmpeg","REG_SZ",$ffmpegexe)
EndIf


; En ligne de commande
If $CmdLine[0]>0 Then
	If CheckFile($CmdLine[1])<>2 Then 
		MsgBox(16,"Erreur !","Le fichier vido spcifi est introuvable !")
	ElseIf CheckFile($ffmpegexe)<>2 Then 
		MsgBox(16,"Erreur !","FFmpeg2Theora est introuvable !")
	Else
		Dim $szDrive, $szDir, $szFName, $szExt
		_PathSplit($CmdLine[1], $szDrive, $szDir, $szFName, $szExt)
		$output=""
		If CheckFile(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Destination"))=1 Then 
			$output=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Destination") & "\" & $szFName & ".ogv"	
		Else
			$output=$szDrive&$szDir&$szFName&".ogv"
		EndIf
		If $output<>"" AND RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","SonSeul")=$GUI_CHECKED Then
			$output&=".ogg"
		Else
			$output&=".ogv"
			if StringLower($szExt)=".ogv" Then $output&=".ogv" ; Eviter l'ecrasement quand source=ogv
		EndIf		
		$caller=_ProcessGetParent(@AutoItPID) ; comment est lanc le script ?
		If ($caller="cmd.exe" OR $caller="command.com") Then ; en ligne de commande : en console
			Run(FFmpeg2Theora($output))
		Else
			Conversion($szFName&$szExt,$output) ; depuis windows : dans une fenetre
		EndIf
	EndIf	
	exit
Endif

; Affichage de l'interface
$win=GuiCreate($nom, 600, 380)
If (Not @compiled) Then GUISetIcon("wtheora.ico")
GUISetFont ("7" , 400)
$context = GUICtrlCreateContextMenu()
$about = GUICtrlCreateMenuItem("A propos", $context)
$codesrc = GUICtrlCreateMenuItem("Code source", $context)

GUICtrlSetStyle(GuiCtrlCreateLabel("Vido", 10, 13, 75),$SS_RIGHT)
$video=GuiCtrlCreateInput("", 90, 10, 450)
GUICtrlSetTip(-1,"Vido  convertir au format Ogg/Vorbis/Theora")
$fvideo=GuiCtrlCreateButton(" ... ", 560, 10,20,20,$BS_ICON)
SetIcon(-10,"video.ico","",0)
GUICtrlSetTip(-1,"Slection du fichier")

GUICtrlSetStyle(GuiCtrlCreateLabel("ffmpeg2theora", 10, 38, 75),$SS_RIGHT)
$ffmpeg=GuiCtrlCreateInput($ffmpegexe, 90, 35, 450)
GUICtrlSetState($ffmpeg,$GUI_DISABLE)
$fffmpeg=GuiCtrlCreateButton(" ... ", 560, 35,20,20,$BS_ICON)
SetIcon(-12,"fred.ico","",0)
GUICtrlSetTip(-1,"Slection du programme")

GUICtrlSetStyle(GuiCtrlCreateLabel("Destination", 10, 63, 75),$SS_RIGHT)
$dest=GuiCtrlCreateInput(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Destination"), 90, 60, 230)
If Not GUICtrlRead($dest) Then GUICtrlSetState (-1,$GUI_DISABLE)
GUICtrlSetTip(-1,"Optionnel: si vide, la nouvelle vido sera dans le mme dossier que celle d'origine")
$fdest=GuiCtrlCreateButton(" ... ", 340, 60,20,20,$BS_ICON)
SetIcon(-11,"fyellow.ico","",0)
GUICtrlSetTip(-1,"Slection du dossier")

GUICtrlSetStyle(GuiCtrlCreateLabel("Autres options", 10, 88, 75),$SS_RIGHT)
GUICtrlSetColor(-1, 0x006633)
$options=GuiCtrlCreateInput(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Options"), 90, 85, 230)
GUICtrlSetTip(-1,"Options de ligne de commande supplmentaires non grs par cette interface")
$hoptions=GuiCtrlCreateButton(" ? ", 340, 85,20,20,$BS_ICON)
SetIcon(-13,"help.ico","",0)
GUICtrlSetTip(-1,"Liste des options supportes par votre version de ffmpeg2theora")
If CheckFile($ffmpegexe)<>2 Then GUICtrlSetState (-1,$GUI_DISABLE)

GUICtrlSetStyle(GuiCtrlCreateLabel("Artist", 10, 113, 75),$SS_RIGHT)
GUICtrlSetColor(-1, 0x0000ff)
$ARTIST=GuiCtrlCreateInput(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","ARTIST"), 90, 110, 270)
GUICtrlSetTip(-1,'Mtadonnes normalises: Inscrivez (centuellement)  ici le "ralisateur" de la vido')
GUICtrlSetStyle(GuiCtrlCreateLabel("Title", 10, 138, 75),$SS_RIGHT)
GUICtrlSetColor(-1, 0x0000ff)
$TITLE=GuiCtrlCreateInput(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","TITLE"), 90, 135, 270)
GUICtrlSetTip(-1,'Mtadonnes normalises: Inscrivez (centuellement)  ici le "titre" de la vido')
GUICtrlSetStyle(GuiCtrlCreateLabel("Date", 10, 163, 75),$SS_RIGHT)
GUICtrlSetColor(-1, 0x0000ff)
$DATE=GuiCtrlCreateInput(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","DATE"), 90, 160, 270)
GUICtrlSetTip(-1,'Mtadonnes normalises: Inscrivez (centuellement)  ici la date de ralisation de la vido')
GUICtrlSetStyle(GuiCtrlCreateLabel("Location", 10, 188, 75),$SS_RIGHT)
GUICtrlSetColor(-1, 0x0000ff)
$LOCATION=GuiCtrlCreateInput(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","LOCATION"), 90, 185, 270)
GUICtrlSetTip(-1,"Mtadonnes normalises: Inscrivez (centuellement)  ici le lieu d'enregistrement de la vido")
GUICtrlSetStyle(GuiCtrlCreateLabel("Organization", 10, 213, 75),$SS_RIGHT)
GUICtrlSetColor(-1, 0x0000ff)
$ORGANIZATION=GuiCtrlCreateInput(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","ORGANIZATION"), 90, 210, 270)
GUICtrlSetTip(-1,'Mtadonnes normalises: Inscrivez (centuellement)  ici le nom de votre "organisation"')
GUICtrlSetStyle(GuiCtrlCreateLabel("Copyright", 10, 238, 75),$SS_RIGHT)
GUICtrlSetColor(-1, 0x0000ff)
$COPYRIGHT=GuiCtrlCreateInput(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","COPYRIGHT"), 90, 235, 270)
GUICtrlSetTip(-1,'Mtadonnes normalises: Inscrivez (centuellement)  ici le propritaire lgal de la vido')
GUICtrlSetStyle(GuiCtrlCreateLabel("License", 10, 263, 75),$SS_RIGHT)
GUICtrlSetColor(-1, 0x0000ff)
$LICENSE=GuiCtrlCreateInput(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","LICENSE"), 90, 260, 270)
GUICtrlSetTip(-1,'Mtadonnes normalises: Inscrivez (centuellement)  ici le type de license de la vido')
GUICtrlSetStyle(GuiCtrlCreateLabel("Contact", 10, 288, 75),$SS_RIGHT)
GUICtrlSetColor(-1, 0x0000ff)
$CONTACT=GuiCtrlCreateInput(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","CONTACT"), 90, 285, 270)
GUICtrlSetTip(-1,'Mtadonnes normalises: Inscrivez (centuellement)  ici vos coordonnes (courriel par exemple)')

GuiCtrlCreateLabel("Largeur:", 380, 63)
GUICtrlSetColor(-1, 0x006633)
$X=GuiCtrlCreateInput(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Largeur"), 430, 60, 40)
GUICtrlSetTip(-1,"On peut laisser vide l'un ou les 2 champs")
GuiCtrlCreateLabel("Hauteur:", 490, 63)
GUICtrlSetColor(-1, 0x006633)
$Y=GuiCtrlCreateInput(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Hauteur"), 540, 60, 40)
GUICtrlSetTip(-1,"On peut laisser vide l'un ou les 2 champs")

GuiCtrlCreateLabel("Qualit vido:", 380, 90)
GUICtrlSetColor(-1, 0x006633)
$qvideo = GUICtrlCreateSlider(445, 83, 150, 30, BitOR($GUI_SS_DEFAULT_SLIDER, $TBS_TOOLTIPS, $TBS_AUTOTICKS))
GUICtrlSetTip(-1,"Qualit par dfaut: 5")
GUICtrlSetLimit(-1, 10, 0)
$tmp=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Qvideo")
If (StringIsDigit($tmp) AND $tmp>=0 AND $tmp<=10) Then
	GUICtrlSetData(-1, $tmp)
Else
	GUICtrlSetData(-1, 5)
EndIF
_GUICtrlSlider_SetTicFreq(-1,1)

GuiCtrlCreateLabel("Luminosit:", 380, 120)
GUICtrlSetColor(-1, 0x006633)
$luminosite = GUICtrlCreateSlider(445, 113, 150, 30, BitOR($GUI_SS_DEFAULT_SLIDER, $TBS_TOOLTIPS, $TBS_AUTOTICKS))
GUICtrlSetTip(-1,"Luminosit par dfaut: 0")
GUICtrlSetLimit(-1, 10, -10)
$tmp=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Luminosite")
If (StringIsDigit($tmp) AND $tmp>=-10 AND $tmp<=10) Then
	GUICtrlSetData(-1, $tmp)
Else
	GUICtrlSetData(-1, 0)
EndIF
_GUICtrlSlider_SetTicFreq(-1,2)

GuiCtrlCreateLabel("Contraste:", 380, 150)
GUICtrlSetColor(-1, 0x006633)
$contraste = GUICtrlCreateSlider(445, 143, 150, 30, BitOR($GUI_SS_DEFAULT_SLIDER, $TBS_TOOLTIPS, $TBS_AUTOTICKS))
GUICtrlSetTip(-1,"Contraste par dfaut: 10")
GUICtrlSetLimit(-1, 100, 0)
$tmp=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Contraste")
If (StringIsDigit($tmp) AND $tmp>=0 AND $tmp<=100) Then
	GUICtrlSetData(-1, $tmp)
Else
	GUICtrlSetData(-1, 10)
EndIF
_GUICtrlSlider_SetTicFreq(-1,10)

GuiCtrlCreateLabel("Gamma:", 380, 180)
GUICtrlSetColor(-1, 0x006633)
$gamma = GUICtrlCreateSlider(445, 173, 150, 30, BitOR($GUI_SS_DEFAULT_SLIDER, $TBS_TOOLTIPS, $TBS_AUTOTICKS))
GUICtrlSetTip(-1,"Gamma par dfaut: 10")
GUICtrlSetLimit(-1, 100, 0)
$tmp=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Gamma")
If (StringIsDigit($tmp) AND $tmp>=0 AND $tmp<=100) Then
	GUICtrlSetData(-1, $tmp)
Else
	GUICtrlSetData(-1, 10)
EndIF
_GUICtrlSlider_SetTicFreq(-1,10)

GuiCtrlCreateLabel("Saturation:", 380, 210)
GUICtrlSetColor(-1, 0x006633)
$saturation = GUICtrlCreateSlider(445, 203, 150, 30, BitOR($GUI_SS_DEFAULT_SLIDER, $TBS_TOOLTIPS, $TBS_AUTOTICKS))
GUICtrlSetTip(-1,"Saturation par dfaut: 10 (Mettre  0 pour N&B)")
GuiCtrlSetData(-1, 30)
GUICtrlSetLimit(-1, 100, 0)
$tmp=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Saturation")
If (StringIsDigit($tmp) AND $tmp>=0 AND $tmp<=100) Then
	GUICtrlSetData(-1, $tmp)
Else
	GUICtrlSetData(-1, 10)
EndIF
_GUICtrlSlider_SetTicFreq(-1,10)

$opttaille=GuiCtrlCreateCheckbox("Optimisation taille", 380, 235)
GUICtrlSetColor(-1, 0x006633)
GuiCtrlSetState(-1, RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","OptTaille"))
If RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","OptTaille")="" Then 
	GuiCtrlSetState(-1,$GUI_CHECKED)
Else
	GuiCtrlSetState(-1,RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","OptTaille"))
EndIf 
GUICtrlSetTip(-1,"Mais ralenti la conversion...")
$noskeleton=GuiCtrlCreateCheckbox("Sans skeleton", 500, 235)
GUICtrlSetColor(-1, 0x006633)
GuiCtrlSetState(-1, RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","NoSkeleton"))
If RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","NoSkeleton")="" Then 
	GuiCtrlSetState(-1,$GUI_CHECKED)
Else
	GuiCtrlSetState(-1,RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","NoSkeleton"))
EndIf 
GUICtrlSetTip(-1,"Conseill pour Itheora !")

GuiCtrlCreateLabel("Qualit audio:", 380, 265)
GUICtrlSetColor(-1, 0x006633)
$qaudio = GUICtrlCreateSlider(445, 258, 150, 30, BitOR($GUI_SS_DEFAULT_SLIDER, $TBS_TOOLTIPS, $TBS_AUTOTICKS))
GUICtrlSetTip(-1,"Qualit par dfaut: 1")
GUICtrlSetLimit(-1, 10, -2)
$tmp=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Qaudio")
If (StringIsDigit($tmp) AND $tmp>=-2 AND $tmp<=10) Then
	GUICtrlSetData(-1, $tmp)
Else
	GUICtrlSetData(-1, 1)
EndIF
_GUICtrlSlider_SetTicFreq(-1,1)

$audio=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Audio")
$muet=GuiCtrlCreateCheckbox("Muet", 380, 290)
GUICtrlSetColor(-1, 0x006633)
GUICtrlSetTip(-1,"Ne cocher aucune case pour garder la configuration audio du fichier d'origine")
if ($audio="Muet") Then GuiCtrlSetState(-1, $GUI_CHECKED)
$mono=GuiCtrlCreateCheckbox("Mono", 430, 290)
GUICtrlSetColor(-1, 0x006633)
GUICtrlSetTip(-1,"Ne cocher aucune case pour garder la configuration audio du fichier d'origine")
if ($audio="Mono") Then GuiCtrlSetState(-1, $GUI_CHECKED)
$stereo=GuiCtrlCreateCheckbox("Stro", 480, 290)
GUICtrlSetColor(-1, 0x006633)
GUICtrlSetTip(-1,"Ne cocher aucune case pour garder la configuration audio du fichier d'origine")
if ($audio="Stereo") Then GuiCtrlSetState(-1, $GUI_CHECKED)
$sonseul=GuiCtrlCreateCheckbox("Son Seul", 530, 290)
GUICtrlSetColor(-1, 0x006633)
GUICtrlSetTip(-1,"Pour ne garder que le son (sans vido !)")
If RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","SonSeul")="" Then 
	GuiCtrlSetState(-1,$GUI_UNCHECKED)
Else
	GuiCtrlSetState(-1,RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","SonSeul"))
EndIf 


$raz=GuiCtrlCreateButton("Raz", 80, 320,40,40, $BS_ICON)
SetIcon(-5,"new.ico","133")
GUICtrlSetTip(-1,"Rinitialiser tous les paramtres  leur valeur par dfaut !")
$razb=GuiCtrlCreateButton(" Rb ", 57, 340,20,20,$BS_ICON)
SetIcon(-14,"newb.ico","",0)
GUICtrlSetTip(-1,"Vider uniquemement les paramtres bleus")
$razv=GuiCtrlCreateButton(" Rv ", 123, 340,20,20,$BS_ICON)
SetIcon(-15,"newg.ico","",0)
GUICtrlSetTip(-1,"Rinitialiser uniquemement les paramtres verts")


$save=GuiCtrlCreateButton("Save", 180, 320,40,40, $BS_ICON)
SetIcon(-6,"save.ico","6")
GUICtrlSetTip(-1,"Sauvegarder ces paramtres (sauf vido  convertir)")

$go=GuiCtrlCreateButton("Go", 280, 320,40,40, $BS_ICON)
SetIcon(-7,"go.ico","238")
GUICtrlSetTip(-1,"Convertir cette vido immdiatement !")
GUICtrlSetState (-1,$GUI_DISABLE)

$cmd=GuiCtrlCreateButton("Info", 380, 320,40,40, $BS_ICON)
SetIcon(-8,"info.ico","24")
GUICtrlSetTip(-1,"Equivalent en ligne de commande ffmpeg2theora")
GUICtrlSetState (-1,$GUI_DISABLE)

$net=GuiCtrlCreateButton("Home", 480, 320,40,40, $BS_ICON)
SetIcon(-9,"home.ico","15")
GUICtrlSetTip(-1,"Site web de cet outil et liens")

If ($Installation) Then Sauve() ; Initialisation des paramtres dans la base de registre au premier lancement

; Gestion du menu
GuiSetState()
While 1
CheckDisable()
Switch GuiGetMsg()
	case $GUI_EVENT_CLOSE
		$modif=0
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","FFmpeg")<>GUICtrlRead($ffmpeg)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Destination")<>GUICtrlRead($dest)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Options")<>GUICtrlRead($options)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Largeur")<>GUICtrlRead($X)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Hauteur")<>GUICtrlRead($Y)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","ARTIST")<>GUICtrlRead($ARTIST)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","TITLE")<>GUICtrlRead($TITLE)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","DATE")<>GUICtrlRead($DATE)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","LOCATION")<>GUICtrlRead($LOCATION)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","ORGANIZATION")<>GUICtrlRead($ORGANIZATION)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","COPYRIGHT")<>GUICtrlRead($COPYRIGHT)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","LICENSE")<>GUICtrlRead($LICENSE)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","CONTACT")<>GUICtrlRead($CONTACT)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Qvideo")<>GUICtrlRead($qvideo)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Qaudio")<>GUICtrlRead($qaudio)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","OptTaille")<>GUICtrlRead($opttaille)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","NoSkeleton")<>GUICtrlRead($noskeleton)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","SonSeul")<>GUICtrlRead($sonseul)) Then $modif=1
		$audio=""		
		If (GUICtrlRead($muet)=$GUI_CHECKED) Then $audio="Muet"
		If (GUICtrlRead($mono)=$GUI_CHECKED) Then $audio="Mono"
		If (GUICtrlRead($stereo)=$GUI_CHECKED) Then $audio="Stereo"		
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Audio")<>$audio) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Luminosite")<>GUICtrlRead($luminosite)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Contraste")<>GUICtrlRead($contraste)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Gamma")<>GUICtrlRead($gamma)) Then $modif=1
		If (RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Saturation")<>GUICtrlRead($saturation)) Then $modif=1
		if ($modif) Then
			If (MsgBox(36,"Attention","Les paramtres ont t modifis par rapport  la configuration prcdente ; Souhaitez vous conserver ces paramtres pour la prochaine fois ?")=6) Then Sauve()
		EndIf
		FileDelete ( @ScriptDir & "\ffmpeg2theora.txt" )
		ExitLoop
	case $muet
		if (GUICtrlRead($muet)=$GUI_CHECKED) Then
			GUICtrlSetState ($mono,$GUI_UNCHECKED)
			GUICtrlSetState ($stereo,$GUI_UNCHECKED)
			GUICtrlSetState ($sonseul,$GUI_UNCHECKED)
		EndIf
	case $mono
		if (GUICtrlRead($mono)=$GUI_CHECKED) Then
			GUICtrlSetState ($muet,$GUI_UNCHECKED)
			GUICtrlSetState ($stereo,$GUI_UNCHECKED)
		EndIf
	case $stereo
		if (GUICtrlRead($stereo)=$GUI_CHECKED) Then
			GUICtrlSetState ($mono,$GUI_UNCHECKED)
			GUICtrlSetState ($muet,$GUI_UNCHECKED)
		EndIf
	case $sonseul
		if (GUICtrlRead($sonseul)=$GUI_CHECKED) Then GUICtrlSetState ($muet,$GUI_UNCHECKED)
	case $net
		ShellExecute("http://opensource.grisambre.net/wtheora")
	case $fvideo
		$fichier=FileOpenDialog("Emplacement du fichier vido ?", @ScriptDir, "Vido (*.avi;*.mp*;*.og*;*.mov;*.wmv;*.mkv)|Tous documents (*.*)", 2 )
		if ($fichier) Then 
			GUICtrlSetData($video,$fichier)
			If Not GUICtrlRead($dest) Then
				Dim $szDrive, $szDir, $szFName, $szExt
				_PathSplit(GUICtrlRead($video), $szDrive, $szDir, $szFName, $szExt)
				GUICtrlSetData($dest,$szDrive&$szDir)
				GUICtrlSetState ($dest,$GUI_DISABLE)
			EndIf
		EndIf
	case $fffmpeg
		$fichier=FileOpenDialog("Emplacement de ffmpeg2theora ?", @ScriptDir, "Programme (*.exe)", 2 )
		if ($fichier) Then GUICtrlSetData($ffmpeg,$fichier)
	case $fdest
		$dossier=FileSelectFolder ("Destination du fichier OGV", @DesktopCommonDir,2,@ScriptDir)
		if ($dossier) Then 
			GUICtrlSetData($dest,$dossier)
			GUICtrlSetState ($dest,$GUI_ENABLE)
		EndIf
	case $save
		Sauve()
	case $raz
		GUICtrlSetData($dest,"")
		GUICtrlSetData($options,"")
		GUICtrlSetData($X,"")
		GUICtrlSetData($Y,"")
		GUICtrlSetData($ARTIST,"")
		GUICtrlSetData($TITLE,"")
		GUICtrlSetData($DATE,"")
		GUICtrlSetData($LOCATION,"")
		GUICtrlSetData($ORGANIZATION,"")
		GUICtrlSetData($COPYRIGHT,"")
		GUICtrlSetData($LICENSE,"")
		GUICtrlSetData($CONTACT,"")
		GUICtrlSetData($qvideo,5)
		GUICtrlSetData($qaudio,1)
		GUICtrlSetState($opttaille,$GUI_CHECKED)
		GUICtrlSetState($noskeleton,$GUI_CHECKED)
		GUICtrlSetState($muet,$GUI_UNCHECKED)
		GUICtrlSetState($mono,$GUI_UNCHECKED)
		GUICtrlSetState($stereo,$GUI_UNCHECKED)
		GUICtrlSetData($luminosite,0)
		GUICtrlSetData($contraste,10)
		GUICtrlSetData($gamma,10)
		GUICtrlSetData($saturation,10)
		GUICtrlSetState ($dest,$GUI_DISABLE)
		GUICtrlSetState ($sonseul,$GUI_UNCHECKED)
	case $razb
		GUICtrlSetData($ARTIST,"")
		GUICtrlSetData($TITLE,"")
		GUICtrlSetData($DATE,"")
		GUICtrlSetData($LOCATION,"")
		GUICtrlSetData($ORGANIZATION,"")
		GUICtrlSetData($COPYRIGHT,"")
		GUICtrlSetData($LICENSE,"")
		GUICtrlSetData($CONTACT,"")
	case $razv
		GUICtrlSetData($options,"")
		GUICtrlSetData($X,"")
		GUICtrlSetData($Y,"")
		GUICtrlSetData($qvideo,5)
		GUICtrlSetData($qaudio,1)
		GUICtrlSetState($opttaille,$GUI_CHECKED)
		GUICtrlSetState($noskeleton,$GUI_CHECKED)
		GUICtrlSetState($muet,$GUI_UNCHECKED)
		GUICtrlSetState($mono,$GUI_UNCHECKED)
		GUICtrlSetState($stereo,$GUI_UNCHECKED)
		GUICtrlSetData($luminosite,0)
		GUICtrlSetData($contraste,10)
		GUICtrlSetData($gamma,10)
		GUICtrlSetData($saturation,10)
		GUICtrlSetState ($sonseul,$GUI_UNCHECKED)
	case $go	
		Dim $szDrive, $szDir, $szFName, $szExt
		_PathSplit(GUICtrlRead($video), $szDrive, $szDir, $szFName, $szExt)
		If CheckFile(GUICtrlRead($dest))=1 Then 
			$destdir=GUICtrlRead($dest)
		Else				
			$destdir=$szDrive & $szDir
		EndIf	
		$output=$destdir&"\"&$szFName
		If GUICtrlRead($sonseul)=$GUI_CHECKED Then
			$output&=".ogg"
		Else
			$output&=".ogv"
			if StringLower($szExt)=".ogv" Then $output&=".ogv" ; Eviter l'ecrasement quand source=ogv
		EndIf	
		GUISetState(@SW_DISABLE,$win)				
		Conversion($szFName&$szExt,$output)
		GUISetState(@SW_ENABLE,$win)
		WinActivate ($nom)
	case $cmd
		Dim $szDrive, $szDir, $szFName, $szExt
		_PathSplit(GUICtrlRead($video), $szDrive, $szDir, $szFName, $szExt)
		If CheckFile(GUICtrlRead($dest))=1 Then 
			$destdir=GUICtrlRead($dest)
		Else				
			$destdir=$szDrive & $szDir
		EndIf	
		$output=$destdir&"\"&$szFName
		If GUICtrlRead($sonseul)=$GUI_CHECKED Then
			$output&=".ogg"
		Else
			$output&=".ogv"
			if StringLower($szExt)=".ogv" Then $output&=".ogv" ; Eviter l'ecrasement quand source=ogv
		EndIf			
		$commande=FFmpeg2Theora($output)
		If (MsgBox(324,"Commande en ligne",$commande&@CRLF&@CRLF&"Copier la commande dans le presse-papier Windows ?")=6) Then ClipPut($commande)
	case $hoptions
		$h=Run ( GUICtrlRead($ffmpeg)&" -h" ,  @ScriptDir , @SW_HIDE, $STDOUT_CHILD)
		$help=""
		While 1
			$help &= StdoutRead($h)
			If @error Then ExitLoop
		Wend
		$h2=Run ( GUICtrlRead($ffmpeg)&" --pp help" ,  @ScriptDir , @SW_HIDE, $STDOUT_CHILD)
		While 1
			$help &= StdoutRead($h2)
			If @error Then ExitLoop
		Wend
		FileDelete ( @ScriptDir & "\ffmpeg2theora.txt" )
		FileWrite(@ScriptDir & "\ffmpeg2theora.txt",$help)
		ShellExecute(@ScriptDir & "\ffmpeg2theora.txt")
	case $about
		MsgBox(64,"A propos de Wtheora",$Apropos)
	case $codesrc
		$dest=FileSaveDialog ( "Enregistrement du code source", @ScriptDir, "Archive compresse (*.zip)", 18 , "wtheora-src.zip")
		If ($dest) Then
			FileInstall("wtheora-src.zip",$dest,1)
		EndIf
EndSwitch
WEnd
exit


Func CheckDisable()
	; Boutons
	If CheckFile(GUICtrlRead($video))=2 AND CheckFile(GUICtrlRead($ffmpeg))=2 Then
		If BitAND(GUICtrlGetState($go),$GUI_DISABLE) Then
			GUICtrlSetState ($go,$GUI_ENABLE)
			GUICtrlSetState ($cmd,$GUI_ENABLE)
		EndIf
	ElseIf BitAND(GUICtrlGetState($go),$GUI_ENABLE) Then
		GUICtrlSetState ($go,$GUI_DISABLE)
		GUICtrlSetState ($cmd,$GUI_DISABLE)
	EndIf
	If CheckFile(GUICtrlRead($ffmpeg))=2 Then
		If BitAND(GUICtrlGetState($hoptions),$GUI_DISABLE) Then	GUICtrlSetState ($hoptions,$GUI_ENABLE)
	ElseIf BitAND(GUICtrlGetState($hoptions),$GUI_ENABLE) Then
		GUICtrlSetState ($hoptions,$GUI_DISABLE)
	EndIf
	; Champs audio
	If GUICtrlRead($muet)=$GUI_CHECKED Then
		If BitAND(GUICtrlGetState($qaudio),$GUI_ENABLE) Then GUICtrlSetState ($qaudio,$GUI_DISABLE)
	ElseIf BitAND(GUICtrlGetState($qaudio),$GUI_DISABLE) Then
		GUICtrlSetState ($qaudio,$GUI_ENABLE)
	EndIf
	; Champs vido
	If GUICtrlRead($sonseul)=$GUI_CHECKED Then
		If BitAND(GUICtrlGetState($X),$GUI_ENABLE) Then 
			GUICtrlSetState ($X,$GUI_DISABLE)
			GUICtrlSetState ($Y,$GUI_DISABLE)
			GUICtrlSetState ($qvideo,$GUI_DISABLE)
			GUICtrlSetState ($luminosite,$GUI_DISABLE)
			GUICtrlSetState ($contraste,$GUI_DISABLE)
			GUICtrlSetState ($gamma,$GUI_DISABLE)
			GUICtrlSetState ($saturation,$GUI_DISABLE)
			GUICtrlSetState ($ARTIST,$GUI_DISABLE)
			GUICtrlSetState ($TITLE,$GUI_DISABLE)
			GUICtrlSetState ($DATE,$GUI_DISABLE)
			GUICtrlSetState ($LOCATION,$GUI_DISABLE)
			GUICtrlSetState ($ORGANIZATION,$GUI_DISABLE)
			GUICtrlSetState ($COPYRIGHT,$GUI_DISABLE)
			GUICtrlSetState ($LICENSE,$GUI_DISABLE)
			GUICtrlSetState ($CONTACT,$GUI_DISABLE)
		EndIf
	ElseIf BitAND(GUICtrlGetState($X),$GUI_DISABLE) Then
			GUICtrlSetState ($X,$GUI_ENABLE)
			GUICtrlSetState ($Y,$GUI_ENABLE)
			GUICtrlSetState ($qvideo,$GUI_ENABLE)
			GUICtrlSetState ($luminosite,$GUI_ENABLE)
			GUICtrlSetState ($contraste,$GUI_ENABLE)
			GUICtrlSetState ($gamma,$GUI_ENABLE)
			GUICtrlSetState ($saturation,$GUI_ENABLE)
			GUICtrlSetState ($ARTIST,$GUI_ENABLE)
			GUICtrlSetState ($TITLE,$GUI_ENABLE)
			GUICtrlSetState ($DATE,$GUI_ENABLE)
			GUICtrlSetState ($LOCATION,$GUI_ENABLE)
			GUICtrlSetState ($ORGANIZATION,$GUI_ENABLE)
			GUICtrlSetState ($COPYRIGHT,$GUI_ENABLE)
			GUICtrlSetState ($LICENSE,$GUI_ENABLE)
			GUICtrlSetState ($CONTACT,$GUI_ENABLE)
	EndIf
	
EndFunc


Func Sauve()
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","FFmpeg","REG_SZ",GUICtrlRead($ffmpeg))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Destination","REG_SZ",GUICtrlRead($dest))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Options","REG_SZ",GUICtrlRead($options))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Largeur","REG_SZ",GUICtrlRead($X))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Hauteur","REG_SZ",GUICtrlRead($Y))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","ARTIST","REG_SZ",GUICtrlRead($ARTIST))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","TITLE","REG_SZ",GUICtrlRead($TITLE))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","DATE","REG_SZ",GUICtrlRead($DATE))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","LOCATION","REG_SZ",GUICtrlRead($LOCATION))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","ORGANIZATION","REG_SZ",GUICtrlRead($ORGANIZATION))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","COPYRIGHT","REG_SZ",GUICtrlRead($COPYRIGHT))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","LICENSE","REG_SZ",GUICtrlRead($LICENSE))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","CONTACT","REG_SZ",GUICtrlRead($CONTACT))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Qvideo","REG_SZ",GUICtrlRead($qvideo))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Qaudio","REG_SZ",GUICtrlRead($qaudio))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","OptTaille","REG_SZ",GUICtrlRead($opttaille))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","NoSkeleton","REG_SZ",GUICtrlRead($noskeleton))
	$audio=""		
	If (GUICtrlRead($muet)=$GUI_CHECKED) Then $audio="Muet"
	If (GUICtrlRead($mono)=$GUI_CHECKED) Then $audio="Mono"
	If (GUICtrlRead($stereo)=$GUI_CHECKED) Then $audio="Stereo"		
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Audio","REG_SZ",$audio)
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Luminosite","REG_SZ",GUICtrlRead($luminosite))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Contraste","REG_SZ",GUICtrlRead($contraste))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Gamma","REG_SZ",GUICtrlRead($gamma))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Saturation","REG_SZ",GUICtrlRead($saturation))
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","SonSeul","REG_SZ",GUICtrlRead($sonseul))
EndFunc


Func FFmpeg2Theora($output)
If $CmdLine[0]>0 Then
	$_ffmpegexe=$ffmpegexe
	$_video=$CmdLine[1]
	$_options=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Options")
	$_x=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Largeur")
	$_y=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Hauteur")
	$_artist=AnsiToUnicode(StringReplace(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","ARTIST"),'"', "'"))
	$_title=AnsiToUnicode(StringReplace(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","TITLE"),'"', "'"))
	$_date=AnsiToUnicode(StringReplace(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","DATE"),'"', "'"))
	$_location=AnsiToUnicode(StringReplace(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","LOCATION"),'"', "'"))
	$_organization=AnsiToUnicode(StringReplace(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","ORGANIZATION"),'"', "'"))
	$_copyright=AnsiToUnicode(StringReplace(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","COPYRIGHT"),'"', "'"))
	$_license=AnsiToUnicode(StringReplace(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","LICENSE"),'"', "'"))
	$_contact=AnsiToUnicode(StringReplace(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","CONTACT"),'"', "'"))
	$_qvideo=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Qvideo")
	$_qaudio=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Qaudio")
	$_opttaille=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","OptTaille")
	$_noskeleton=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","NoSkeleton")
	$_audio=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Audio")	
	$_luminosite=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Luminosite")/10
	$_contraste=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Contraste")/10
	$_gamma=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Gamma")/10
	$_saturation=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","Saturation")/10
	$_sonseul=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wtheora","SonSeul")
Else
	$_ffmpegexe=GUICtrlRead($ffmpeg)
	$_video=GUICtrlRead($video)
	$_options=GUICtrlRead($options)
	$_x=GUICtrlRead($X)
	$_y=GUICtrlRead($Y)
	$_artist=AnsiToUnicode(StringReplace(GUICtrlRead($ARTIST),'"', "'"))
	$_title=AnsiToUnicode(StringReplace(GUICtrlRead($TITLE),'"', "'"))
	$_date=AnsiToUnicode(StringReplace(GUICtrlRead($DATE),'"', "'"))
	$_location=AnsiToUnicode(StringReplace(GUICtrlRead($LOCATION),'"', "'"))
	$_organization=AnsiToUnicode(StringReplace(GUICtrlRead($ORGANIZATION),'"', "'"))
	$_copyright=AnsiToUnicode(StringReplace(GUICtrlRead($COPYRIGHT),'"', "'"))
	$_license=AnsiToUnicode(StringReplace(GUICtrlRead($LICENSE),'"', "'"))
	$_contact=AnsiToUnicode(StringReplace(GUICtrlRead($CONTACT),'"', "'"))
	$_qvideo=GUICtrlRead($qvideo)
	$_qaudio=GUICtrlRead($qaudio)
	$_opttaille=GUICtrlRead($opttaille)
	$_noskeleton=GUICtrlRead($noskeleton)
	$_audio=""		
	If (GUICtrlRead($muet)=$GUI_CHECKED) Then $_audio="Muet"
	If (GUICtrlRead($mono)=$GUI_CHECKED) Then $_audio="Mono"
	If (GUICtrlRead($stereo)=$GUI_CHECKED) Then $_audio="Stereo"	
	$_luminosite=GUICtrlRead($luminosite)/10
	$_contraste=GUICtrlRead($contraste)/10
	$_gamma=GUICtrlRead($gamma)/10
	$_saturation=GUICtrlRead($saturation)/10
	$_sonseul=GUICtrlRead($sonseul)
EndIf
$commande='"' & $_ffmpegexe & '"'
If $_options Then $commande&=" "&$_options
If $output Then $commande&=' -o "' & StringReplace($output,"\\","\") & '"'
if $_artist Then $commande&=' --artist="' & $_artist & '"'
if $_title Then $commande&=' --title="' & $_title & '"'
if $_date Then $commande&=' --date="' & $_date & '"'
if $_location Then $commande&=' --location="' & $_location & '"'
if $_organization Then $commande&=' --organization="' & $_organization & '"'
if $_copyright Then $commande&=' --copyright="' & $_copyright & '"'
if $_license Then $commande&=' --license="' & $_license & '"'
if $_contact Then $commande&=' --contact="' & $_contact & '"'
if $_audio="Mono" Then $commande&=" -c 1" 
if $_audio="Stereo" Then $commande&=" -c 2"
if $_opttaille=$GUI_CHECKED Then $commande&=" --optimize"
if $_noskeleton=$GUI_CHECKED Then $commande&=" --no-skeleton"
if $_sonseul=$GUI_CHECKED Then 
	$commande&=" --novideo"
Else
	if StringIsDigit($_qvideo) AND $_qvideo<>5 Then $commande&=" -v " & $_qvideo
	if $_luminosite<>0 Then $commande&=" -B " & $_luminosite
	if $_contraste<>1 Then $commande&=" -C " & $_contraste
	if $_gamma<>1 Then $commande&=" -G " & $_gamma
	if $_saturation<>1 Then $commande&=" -Z " & $_saturation
	if StringIsDigit($_x) Then $commande&=" -x " & $_x
	if StringIsDigit($_y) Then $commande&=" -y " & $_y
	if $_audio="Muet" Then $commande&=" --noaudio"
EndIf
if StringIsDigit($_qaudio) AND $_qaudio<>1 Then $commande&=" -a " & $_qaudio
$commande&=' "' & $_video & '"'
return($commande)
EndFunc


Func AnsiToUnicode($txt)
return BinaryToString(StringToBinary($txt,4),1)
EndFunc


Func Temps($s)
If $s<60 Then 
	return(Int($s)&"s")
ElseIf $s<3600 Then
	return(Int($s/60)&"m "&Int(Mod($s,60))&"s")
Else
	return(Int($s/3600)&"h "&Int(Mod($s,3600)/60)&"m "&Int(Mod($s,60))&"s")
EndIf
EndFunc


Func Conversion($nom,$output)
$titre="Conversion de "&$nom
$win2=GuiCreate($titre&" en cours...", 400, 250,-1,-1,$WS_EX_OVERLAPPEDWINDOW)
If (Not @compiled) Then GUISetIcon("wtheora.ico")
GUISetFont ("9" , 400)
$etat=GuiCtrlCreateLabel("", 100, 45,200,20)
GUICtrlSetStyle(-1,$SS_CENTER)
$progress=GUICtrlCreateProgress(10,75,375,40,1)
$lp=GuiCtrlCreateLabel("Priorit :", 150, 175)
$priorite=GUICtrlCreateCombo ( "Basse", 200, 170, 150,20,3)
GUICtrlSetData(-1, "Sous la normale|Normale|Au dessus de normale|Haute", "Normale")
$stop=GUICtrlCreateButton ( " Interruption ", 50, 170,80 )
GuiSetState(@SW_SHOW,$win2)
If $CmdLine[0]>0 Then 
	$taille=FileGetSize($CmdLine[1])
Else
	$taille=FileGetSize(GUICtrlRead($video))
EndIf
$debut=TimerInit ()
$ffpid=Run(FFmpeg2Theora($output),@ScriptDir , @SW_HIDE, $STDERR_CHILD )	
$FinManuelle=0
while ProcessExists($ffpid)				
	$temps=TimerDiff($debut)
	$stats=ProcessGetStats($ffpid,1)
	$p=$stats[3]/$taille*100
	if $p > 100 Then $p=100
	GUICtrlSetData($progress,$p)
	If $temps<3000 Then 
		GUICtrlSetData($etat,Int($p) & " %")
	Else					
		$restant=(($temps*100/$p)-$temps)/1000
		GUICtrlSetData($etat,Int($p) & " % (" & Temps($restant) & " restantes)")
	EndIf
	$temps=TimerInit ()
	while TimerDiff($temps)<1000
		$msg=GuiGetMsg()
		If $msg=$stop Then 
			$FinManuelle=1
			GUICtrlSetState($stop,$GUI_DISABLE)					
			ProcessClose($ffpid)
		EndIf
		If $msg=$priorite Then
			If GUICtrlRead($priorite)="Basse" Then ProcessSetPriority($ffpid,0)
			If GUICtrlRead($priorite)="Sous la normale" Then ProcessSetPriority($ffpid,1)
			If GUICtrlRead($priorite)="Normale" Then ProcessSetPriority($ffpid,2)
			If GUICtrlRead($priorite)="Au dessus de normale" Then ProcessSetPriority($ffpid,3)
			If GUICtrlRead($priorite)="Haute" Then ProcessSetPriority($ffpid,4)					
		EndIf
	Wend
Wend
GUICtrlSetState($priorite,$GUI_DISABLE)
GUICtrlSetData($stop,"Fermer")
WinSetTitle ( $titre&" en cours...", "", $title&" termine !" )
If Not $FinManuelle Then
	GUICtrlSetData($progress,100)
	GUICtrlSetData($etat,"100 %")
EndIf			
GUICtrlSetState($stop,$GUI_ENABLE)			
$infos=""
While 1
	$infos&=StderrRead($ffpid)
	If @error Then ExitLoop			    
Wend			
$vlc = RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\VideoLAN\VLC", "")
If CheckFile($vlc)<>2 Then 
	$vlc="C:\Program Files\VideoLAN\VLC\vlc.exe"
EndIf
if CheckFile($vlc)<>2 Then 
	$vlc="" 
EndIf	
If $infos Then 
	$infos=StringReplace ( $infos, @CR & " ", @CRLF & " ")
	GUICtrlSetState($priorite,$GUI_HIDE)
	GUICtrlSetState($etat,$GUI_HIDE)
	GUICtrlSetState($lp,$GUI_HIDE)
	GUICtrlSetState($progress,$GUI_HIDE)
	GUICtrlSetPos($stop,100,185)
	$visu=GUICtrlCreateButton ( " Visualiser ", 200, 185,80)
	GUICtrlSetTip(-1,"Ncessite VLC install sur le systme.")
	If (CheckFile($output)<>2 AND $vlc) Then GUICtrlSetState($visu,$GUI_DISABLE)
	GUISetFont ("8" , 400)
	If StringLen($infos)>65000 Then
		$i1=StringLeft ( $infos, 32000)
		$i1=StringLeft($infos,StringInStr($i1,@CRLF,0,-1)+2)
		$i2=StringRight ( $infos, 32000)
		$infos=$i1 & "(...)" & @CRLF & $i2
	EndIf
	GUICtrlCreateEdit($infos,5,5,385,170,BitOr($ES_MULTILINE,$ES_READONLY,$WS_VSCROLL))	
	GUICtrlSetTip(-1,"Informations renvoyes par ffmpeg2theora")		
EndIf
Do	
	$msg=GuiGetMsg()
	If $infos AND $msg=$visu Then ShellExecute($vlc,'"'&$output&'"')
Until $msg=$stop
GUIDelete($win2)
EndFunc


Func _ProcessGetParent($i_pid)
    Local Const $TH32CS_SNAPPROCESS = 0x00000002
   
    Local $a_tool_help = DllCall("Kernel32.dll", "long", "CreateToolhelp32Snapshot", "int", $TH32CS_SNAPPROCESS, "int", 0)
    If IsArray($a_tool_help) = 0 Or $a_tool_help[0] = -1 Then Return SetError(1, 0, $i_pid)
   
    Local $tagPROCESSENTRY32 = _
        DllStructCreate _
            ( _
                "dword dwsize;" & _
                "dword cntUsage;" & _
                "dword th32ProcessID;" & _
                "uint th32DefaultHeapID;" & _
                "dword th32ModuleID;" & _
                "dword cntThreads;" & _
                "dword th32ParentProcessID;" & _
                "long pcPriClassBase;" & _
                "dword dwFlags;" & _
                "char szExeFile[260]" _
            )
    DllStructSetData($tagPROCESSENTRY32, 1, DllStructGetSize($tagPROCESSENTRY32))
   
    Local $p_PROCESSENTRY32 = DllStructGetPtr($tagPROCESSENTRY32)
   
    Local $a_pfirst = DllCall("Kernel32.dll", "int", "Process32First", "long", $a_tool_help[0], "ptr", $p_PROCESSENTRY32)
    If IsArray($a_pfirst) = 0 Then Return SetError(2, 0, $i_pid)
   
    Local $a_pnext, $i_return = 0
    If DllStructGetData($tagPROCESSENTRY32, "th32ProcessID") = $i_pid Then
        $i_return = DllStructGetData($tagPROCESSENTRY32, "th32ParentProcessID")
        DllCall("Kernel32.dll", "int", "CloseHandle", "long", $a_tool_help[0])
        If $i_return Then Return $i_return
        Return $i_pid
    EndIf
   
    While 1
        $a_pnext = DLLCall("Kernel32.dll", "int", "Process32Next", "long", $a_tool_help[0], "ptr", $p_PROCESSENTRY32)
        If IsArray($a_pnext) And $a_pnext[0] = 0 Then ExitLoop
        If DllStructGetData($tagPROCESSENTRY32, "th32ProcessID") = $i_pid Then
            $i_return = DllStructGetData($tagPROCESSENTRY32, "th32ParentProcessID")
            If $i_return Then ExitLoop
            $i_return = $i_pid
            ExitLoop
        EndIf
    WEnd
   
    If $i_return = "" Then $i_return = $i_pid
   
    DllCall("Kernel32.dll", "int", "CloseHandle", "long", $a_tool_help[0])
	
	$list = ProcessList()
	for $i = 1 to $list[0][0]
		if $list[$i][1]=$i_return Then Return $list[$i][0]
	next
    Return $i_return
EndFunc


Func SetIcon($pos,$nom,$alt,$taille=1)
If (@compiled) Then
	GUICtrlSetImage(-1,  @ScriptFullPath,  $pos,$taille)
ElseIf CheckFile($nom)=2 Then
	GUICtrlSetImage(-1, $nom)
ElseIf $alt Then
	GUICtrlSetImage(-1, "shell32.dll", $alt)
EndIf
EndFunc


Func CheckFile($file) ; renvoie 0=existe pas, 1=dossier 2=fichier
If Not FileExists($file) Then return 0
If StringInStr($file,"*") Then return 0
If StringInStr($file,"?") Then return 0
$attrib=FileGetAttrib($file)
If @error Then return 0
If StringInStr($attrib, "D") Then return 1
return 2
EndFunc


Func Licence()
If FileGetSize(@ScriptDir &"\Licence_CeCILL_V2-fr.txt")<>21979 Then FileInstall("Licence_CeCILL_V2-fr.txt", @ScriptDir &"\Licence_CeCILL_V2-fr.txt",1)
$win0=GuiCreate("Contrat de Licence Wtheora", 500, 400,-1,-1,$WS_EX_OVERLAPPEDWINDOW)
If (Not @compiled) Then GUISetIcon("wtheora.ico")
GUISetFont ("8" , 400)
GuiCtrlCreateLabel($Apropos, 40, 10,420,150)
GUICtrlCreateEdit(FileRead(@ScriptDir &"\Licence_CeCILL_V2-fr.txt"),10,155,480,170,BitOr($ES_MULTILINE,$ES_READONLY,$WS_VSCROLL))
GUISetFont ("9" , 400)
$ok=GUICtrlCreateButton ( " Accepter ", 60, 340,80)
$nok=GUICtrlCreateButton ( " Refuser ", 210, 340,80)
$cecill=GUICtrlCreateButton ( " Cecill ? ", 360, 340,80)
GUICtrlSetTip(-1,"http://www.cecill.info")
GuiSetState(@SW_SHOW,$win0)
While 1
	$msg=GuiGetMsg()
	If $msg=$cecill Then ShellExecute("http://www.cecill.info")
	If $msg=$ok Then
		GUIDelete($win0)
		return 1
	EndIf
	If $msg=$nok Then
		GUIDelete($win0)
		return 0
	EndIf
Wend
EndFunc